package HelloServer;
import java.rmi.*;
import java.rmi.server.*;
import HelloInterface.*;


public class HelloImpl extends UnicastRemoteObject  implements HelloWorldInterface 
{
  	private String theName;
	private float myPrice;
    public HelloImpl(String myName) throws java.rmi.RemoteException 
	{
		//super();
		System.out.println("after super");
		theName=myName;
		myPrice=5000;
	
   }
  
   public String sayHello(String name) throws java.rmi.RemoteException 
   {
      return "my name is "+theName+ " and myPrice= " + myPrice;
   }

	//every time we call this function we increase the "myPrice" by 100
	public void incPrice() throws java.rmi.RemoteException
	{
		//deliberately I want to make this method NOT THREAD-SAFE to demonstrate my point
		float temp;
		//this is the place where context switch might happen and our price might be corrupted
		temp= myPrice + 100;
		myPrice=temp;
	}

	//every time we call this function we increase the "myPrice" by 100
	public void decPrice() throws java.rmi.RemoteException
	{
		//deliberately I want to make this method NOT THREAD-SAFE to demonstrate my point
		float temp;
		//this is the place where context switch might happen and our price might be corrupted
		temp= myPrice - 100;
		myPrice=temp;
	}
} // end class
